<?php

namespace OCA\GrueneGroupfolderManagement\Constants;

class Constants {
	public const LOCAL_GROUP_LEVEL = 'DE:ORTSVERBAND';
	public const COUNTY_CHAPTER_LEVEL = 'DE:KREISVERBAND';
	public const EXECUTIVE_BOARD = 'Vorstand';
	public const EXECUTIVE_BOARD_MANAGER = 'Vorstand & Geschäftsführung';
	public const DEFAULT_DIRECTORIES = [self::EXECUTIVE_BOARD, self::EXECUTIVE_BOARD_MANAGER];
	public const DEFAULT_GROUPS = [
		'EXECUTIVE_BOARD' => [
			'name' => 'Vorstand',
			'levels' => [
				self::LOCAL_GROUP_LEVEL,
				self::COUNTY_CHAPTER_LEVEL,
			],
			'groups' => [
				'EXECUTIVE_BOARD'
			]
		],
		'EXECUTIVE_BOARD_PLUS_MANAGER' => [
			'name' => 'Vorstand & Geschäftsführung',
			'levels' => [
				self::LOCAL_GROUP_LEVEL,
				self::COUNTY_CHAPTER_LEVEL,
			],
			'groups' => [
				'EXECUTIVE_BOARD',
				'MANAGER'
			]
		]
	];
	public const BV_KEY_LENGTH = 1;
	public const LV_KEY_LENGTH = 3;
	public const KV_KEY_LENGTH = 6;
	public const OV_KEY_LENGTH = 8;
	public const BV_TYPE = 'BV';
	public const LV_TYPE = 'LV';
	public const KV_TYPE = 'KV';
	public const OV_TYPE = 'OV';
	public const RV_Type = 'RV';
}
