<?php

namespace OCA\GrueneGroupfolderManagement\Converter;

class DivisionConverter {
	/**
	 * @var OrganizationConverter
	 */
	protected $organizationConverter;

	public function __construct(OrganizationConverter $organizationConverter) {
		$this->organizationConverter = $organizationConverter;
	}

	public function convertToEntity(array $result) {
		$entity = new \OCA\GrueneGroupfolderManagement\Model\Division();

		if (isset($result['type'])) {
			$entity->setType($result['type']);
		}

		if (isset($result['organization'])) {
			$entity->setOrganization($this->organizationConverter->convertToEntity($result['organization']));
		}

		if (isset($result['name'])) {
			$entity->setName($result['name']);
		}

		if (isset($result['id'])) {
			$entity->setId($result['id']);
		}

		return $entity;
	}
}
