<?php

namespace OCA\GrueneGroupfolderManagement\Db;

use JsonSerializable;

use OCP\AppFramework\Db\Entity;

class GroupMember extends Entity implements JsonSerializable {
	/**
	 * @var int
	 */
	protected $groupId;

	/**
	 * @var string
	 */
	protected $mappingType;

	/**
	 * @var string
	 */
	protected $mappingId;

	/**
	 * @var string
	 */
	protected $type;

	/**
	 * @var Group
	 */
	protected $group;

	public function __construct() {
		$this->addType('groupId', 'integer');
	}

	public function getGroup() {
		return $this->group;
	}

	public function setGroup(Group $group) {
		$this->group = $group;
	}

	public function jsonSerialize(): mixed {
		return [
			'id' => $this->id,
			'groupId' => $this->groupId,
			'mappingType' => $this->mappingType,
			'mappingId' => $this->mappingId,
			'type' => $this->type,
		];
	}
}
