<?php

declare(strict_types=1);

namespace OCA\GrueneGroupfolderManagement\Migration;

use Closure;
use OCP\DB\ISchemaWrapper;
use OCP\DB\Types;
use OCP\Migration\IOutput;
use OCP\Migration\SimpleMigrationStep;

/**
 * Auto-generated migration step: Please modify to your needs!
 */
class Version0009Date20210811104545 extends SimpleMigrationStep {
	/**
	 * @param IOutput $output
	 * @param Closure $schemaClosure The `\Closure` returns a `ISchemaWrapper`
	 * @param array $options
	 * @return null|ISchemaWrapper
	 */
	public function changeSchema(IOutput $output, Closure $schemaClosure, array $options): ?ISchemaWrapper {
		/** @var ISchemaWrapper $schema */
		$schema = $schemaClosure();
		if (!$schema->hasTable('gruenegfm_mapping')) {
			$table = $schema->createTable('gruenegfm_mapping');
			$table->addColumn('id', Types::INTEGER, [
				'autoincrement' => true,
				'notnull' => true,
				'unsigned' => true,
				'length' => 4,
			]);
			$table->addColumn('division_key', Types::STRING, [
				'length' => 8,
				'notnull' => true,
			]);
			$table->addColumn('index', Types::STRING, [
				'length' => 64,
				'notnull' => false,
			]);
			$table->addColumn('foreign_type', Types::STRING, [
				'length' => 16,
				'notnull' => false,
			]);
			$table->addColumn('foreign_key', Types::STRING, [
				'length' => 64,
				'notnull' => false,
			]);
			$table->addUniqueIndex(['division_key', 'index', 'foreign_type', 'foreign_key'], 'unique_mapping');
			$table->setPrimaryKey(['id'], 'gruene_mapping');
		}
		if (!$schema->hasTable('gruenegfm_division_groups')) {
			$table = $schema->createTable('gruenegfm_division_groups');
			$table->addColumn('id', Types::INTEGER, [
				'length' => 10,
				'unsigned' => true,
				'notnull' => true,
				'autoincrement' => true,
			]);
			$table->addColumn('division_key', Types::STRING, [
				'length' => 8,
				'notnull' => true,
			]);
			$table->addColumn('division_acl_permission', Types::INTEGER, [
				'length' => 11,
				'notnull' => true,
				'default' => 1,
			]);
			$table->addColumn('division_acl_mask', Types::INTEGER, [
				'length' => 11,
				'notnull' => true,
				'default' => 1,
			]);
			$table->addColumn('member_acl_permission', Types::INTEGER, [
				'length' => 11,
				'notnull' => true,
				'default' => 1,
			]);
			$table->addColumn('member_acl_mask', Types::INTEGER, [
				'length' => 11,
				'notnull' => true,
				'default' => 1,
			]);
			$table->addColumn('admin_acl_permission', Types::INTEGER, [
				'length' => 11,
				'notnull' => true,
				'default' => 1,
			]);
			$table->addColumn('admin_acl_mask', Types::INTEGER, [
				'length' => 11,
				'notnull' => true,
				'default' => 1,
			]);
			$table->addColumn('type', Types::STRING, [
				'length' => 64,
				'notnull' => false,
			]);
			$table->addColumn('name', Types::STRING, [
				'length' => 64,
				'notnull' => false,
			]);
			$table->addUniqueIndex(['division_key', 'name'], 'unique_group');
			$table->setPrimaryKey(['id'], 'gruene_division_groups');
		}
		if (!$schema->hasTable('gruenegfm_groups_members')) {
			$table = $schema->createTable('gruenegfm_groups_members');
			$table->addColumn('id', Types::INTEGER, [
				'length' => 10,
				'unsigned' => true,
				'notnull' => true,
				'autoincrement' => true,
			]);
			$table->addColumn('group_id', Types::INTEGER, [
				'length' => 10,
				'unsigned' => true,
				'notnull' => true,
			]);
			$table->addColumn('mapping_type', Types::STRING, [
				'length' => 64,
				'notnull' => false,
			]);
			$table->addColumn('mapping_id', Types::STRING, [
				'length' => 64,
				'notnull' => false,
			]);
			$table->addColumn('type', Types::STRING, [
				'length' => 10,
				'default' => '0',
				'notnull' => true,
			]);
			$table->addUniqueIndex(['group_id', 'mapping_type', 'mapping_id', 'type'], 'unique_member');
			$table->setPrimaryKey(['id'], 'gruene_groups_members');
		}
		return $schema;
	}
}
