<?php

namespace OCA\GrueneGroupfolderManagement\Model;

use OCA\GrueneGroupfolderManagement\Groups\GroupName;
use OCA\GrueneGroupfolderManagement\Model\Api\Group;

class DivisionGroup implements \JsonSerializable {
	/**
	 * @var Division
	 */
	protected $division;

	/**
	 * @var Group
	 */
	protected $group;

	public function __construct(Division $division, Group $group) {
		$this->division = $division;
		$this->group = $group;
	}

	public function getDivision() : Division {
		return $this->division;
	}

	public function getGroup() : Group {
		return $this->group;
	}

	public function jsonSerialize(): mixed {
		return array_merge(
			$this->group->jsonSerialize(),
			[
				'groupName' => GroupName::sherpa($this)
			]
		);
	}
}
